#include "library.lua"
#include "setup.lua"
--#include "ALSmenu.lua"

function init()
    -- inits--
    DoorsInit = FindBodies("ALSdoor", true)
    honksInit = FindShapes("ALShorn", true)
    NoclipInit = FindShapes("noclip", true)

    -- keys--
    Setup()
    ReloadKeys()

    -- sonds inits--
    chimeList = {}
    chimeList[#chimeList + 1] = LoadLoop("sound/chime01.ogg")
    chimeList[#chimeList + 1] = LoadLoop("sound/chime02.ogg")

    clickList = {}
    clickList[#clickList + 1] = LoadSound("sound/beepon.ogg")
    clickList[#clickList + 1] = LoadSound("sound/beepoff.ogg")
    clickList[#clickList + 1] = LoadSound("sound/click.ogg")

    doorList = {}
    doorList[#doorList + 1] = LoadLoop("sound/caropen.ogg")
    doorList[#doorList + 1] = LoadLoop("sound/carclose.ogg")

    honkList = {}
    honkList[#honkList + 1] = LoadLoop("sound/honk01.ogg")
    honkList[#honkList + 1] = LoadLoop("sound/honk02.ogg")
    honkList[#honkList + 1] = LoadLoop("sound/honk03.ogg")
    honkList[#honkList + 1] = LoadLoop("sound/honk04.ogg")

    sirenPrimary = {}
    sirenPrimary[#sirenPrimary + 1] = LoadLoop("sound/sirenP01.ogg")
    sirenPrimary[#sirenPrimary + 1] = LoadLoop("sound/sirenP02.ogg")
    sirenPrimary[#sirenPrimary + 1] = LoadLoop("sound/sirenP03.ogg")

    sirenSecondary = {}
    sirenSecondary[#sirenSecondary + 1] = LoadLoop("sound/sirenS01.ogg")
    sirenSecondary[#sirenSecondary + 1] = LoadLoop("sound/sirenS02.ogg")
    sirenSecondary[#sirenSecondary + 1] = LoadLoop("sound/sirenS03.ogg")

    sirenTertiary = {}
    sirenTertiary[#sirenTertiary + 1] = LoadLoop("sound/sirenT01.ogg")
    sirenTertiary[#sirenTertiary + 1] = LoadLoop("sound/sirenT02.ogg")
    sirenTertiary[#sirenTertiary + 1] = LoadLoop("sound/sirenT03.ogg")

end

function tick(dt)
    -- ==============--
    --  New bodies  --
    -- ==============-- 

    SetFloat("lightsf", GetFloat(pathUi.."lightsf"))
    SetFloat("lightst", GetFloat(pathUi.."lightst"))
    SetFloat("HighBeam", GetFloat(pathUi.."HighBeam"))
    SetFloat("EmLights", GetFloat(pathUi.."EmLights"))

    honksInit = FindShapes("ALShorn", true)
    DoorsInit = FindBodies("ALSdoor", true)
    NoclipInit = FindShapes("noclip", true)

    Noclip(NoclipInit)

    -- =========--
    --  doors  --
    -- =========--
    if GetBool(pathUi .. "ClickDoor") then
        DoorYLVF("open", "close", DoorsInit)
    end
    if GetBool(pathUi .. "HoldDoor") then 
        DoorClick(DoorsInit) 
    end
    if GetBool(pathUi .. "OpenWhenExit") then
        DoorExit("open", "close", DoorsInit)
    end

    -- =========--
    --  Sonds  --
    -- =========--
    honkNsiren(honksInit, sirenPrimary, sirenSecondary, sirenTertiary, honkList, honksCtrl)
    beepclik(honksInit, clickList, lightKeys)

end

